Fix the downgrade function of cfgupgrade
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         test/autotools \
107         lib \
108         lib/build \
109         lib/client \
110         lib/cmdlib \
111         lib/confd \
112         lib/http \
113         lib/hypervisor \
114         lib/impexpd \
115         lib/masterd \
116         lib/rapi \
117         lib/server \
118         lib/tools \
119         lib/utils \
120         lib/watcher \
121         man \
122         qa \
123         test \
124         test/data \
125         test/data/bdev-rbd \
126         test/data/ovfdata \
127         test/data/ovfdata/other \
128         test/py \
129         tools
130
131 ALL_APIDOC_HS_DIRS = \
132         $(APIDOC_HS_DIR) \
133         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
134
135 BUILDTIME_DIR_AUTOCREATE = \
136         scripts \
137         $(APIDOC_DIR) \
138         $(ALL_APIDOC_HS_DIRS) \
139         $(APIDOC_PY_DIR) \
140         $(COVERAGE_DIR) \
141         $(COVERAGE_HS_DIR) \
142         $(COVERAGE_PY_DIR) \
143         .hpc
144
145 BUILDTIME_DIRS = \
146         $(BUILDTIME_DIR_AUTOCREATE) \
147         doc/html \
148         doc/man-html
149
150 DIRCHECK_EXCLUDE = \
151         $(BUILDTIME_DIRS) \
152         ganeti-[0-9]*.[0-9]*.[0-9]* \
153         doc/html/_* \
154         doc/man-html/_* \
155         autom4te.cache
156
157 # some helper vars
158 COVERAGE_DIR = doc/coverage
159 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
160 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
161 APIDOC_DIR = doc/api
162 APIDOC_PY_DIR = $(APIDOC_DIR)/py
163 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
164
165 MAINTAINERCLEANFILES = \
166         $(maninput) \
167         doc/install-quick.rst \
168         doc/news.rst \
169         doc/upgrade.rst \
170         vcs-version
171
172 maintainer-clean-local:
173         rm -rf $(BUILDTIME_DIRS)
174
175 CLEANFILES = \
176         $(addsuffix /*.py[co],$(DIRS)) \
177         $(addsuffix /*.hi,$(HS_DIRS)) \
178         $(addsuffix /*.o,$(HS_DIRS)) \
179         $(PYTHON_BOOTSTRAP) \
180         epydoc.conf \
181         $(REPLACE_VARS_SED) \
182         $(SHELL_ENV_INIT) \
183         daemons/daemon-util \
184         daemons/ganeti-cleaner \
185         devel/squeeze-amd64.tar.gz \
186         devel/squeeze-amd64.conf \
187         $(mandocrst) \
188         doc/manpages-enabled.rst \
189         $(BUILT_EXAMPLES) \
190         doc/examples/bash_completion \
191         doc/examples/bash_completion-debug \
192         lib/_generated_rpc.py \
193         $(man_MANS) \
194         $(manhtml) \
195         tools/kvm-ifup \
196         tools/users-setup \
197         tools/vcluster-setup \
198         stamp-directories \
199         stamp-srclinks \
200         $(nodist_pkgpython_PYTHON) \
201         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
202         $(HS_BUILT_TEST_HELPERS) \
203         src/ganeti-confd \
204         src/ganeti-luxid \
205         src/ganeti-mond \
206         .hpc/*.mix src/*.tix test/hs/*.tix \
207         doc/hs-lint.html
208
209 GENERATED_FILES = \
210         $(built_base_sources) \
211         $(BUILT_PYTHON_SOURCES) \
212         $(PYTHON_BOOTSTRAP)
213
214 HS_GENERATED_FILES =
215 if WANT_HTOOLS
216 HS_GENERATED_FILES += $(HS_PROGS)
217 if ENABLE_CONFD
218 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
219 endif
220
221 if ENABLE_MOND
222 HS_GENERATED_FILES += src/ganeti-mond
223 endif
224 endif
225
226 built_base_sources = \
227         stamp-directories \
228         stamp-srclinks
229
230 built_python_base_sources = \
231         lib/_autoconf.py \
232         lib/_vcsversion.py
233
234 BUILT_PYTHON_SOURCES = \
235         $(built_python_base_sources) \
236         lib/_generated_rpc.py
237
238 # Generating the RPC wrappers depends on many things, so make sure
239 # it's built at the end of the built sources
240 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
241
242 # these are all built from the underlying %.in sources
243 BUILT_EXAMPLES = \
244         doc/examples/ganeti-kvm-poweroff.initd \
245         doc/examples/ganeti.cron \
246         doc/examples/ganeti.initd \
247         doc/examples/ganeti.logrotate \
248         doc/examples/ganeti-master-role.ocf \
249         doc/examples/ganeti-node-role.ocf \
250         doc/examples/gnt-config-backup \
251         doc/examples/hooks/ipsec
252
253 nodist_pkgpython_PYTHON = \
254         $(BUILT_PYTHON_SOURCES)
255
256 noinst_PYTHON = \
257         lib/build/__init__.py \
258         lib/build/shell_example_lexer.py \
259         lib/build/sphinx_ext.py
260
261 pkgpython_PYTHON = \
262         lib/__init__.py \
263         lib/asyncnotifier.py \
264         lib/backend.py \
265         lib/bdev.py \
266         lib/bootstrap.py \
267         lib/cli.py \
268         lib/compat.py \
269         lib/config.py \
270         lib/constants.py \
271         lib/daemon.py \
272         lib/errors.py \
273         lib/hooksmaster.py \
274         lib/ht.py \
275         lib/jqueue.py \
276         lib/jstore.py \
277         lib/locking.py \
278         lib/luxi.py \
279         lib/mcpu.py \
280         lib/netutils.py \
281         lib/objects.py \
282         lib/opcodes.py \
283         lib/outils.py \
284         lib/ovf.py \
285         lib/pathutils.py \
286         lib/qlang.py \
287         lib/query.py \
288         lib/rpc.py \
289         lib/rpc_defs.py \
290         lib/runtime.py \
291         lib/serializer.py \
292         lib/ssconf.py \
293         lib/ssh.py \
294         lib/storage.py \
295         lib/uidpool.py \
296         lib/vcluster.py \
297         lib/network.py \
298         lib/workerpool.py
299
300 client_PYTHON = \
301         lib/client/__init__.py \
302         lib/client/gnt_backup.py \
303         lib/client/gnt_cluster.py \
304         lib/client/gnt_debug.py \
305         lib/client/gnt_group.py \
306         lib/client/gnt_instance.py \
307         lib/client/gnt_job.py \
308         lib/client/gnt_node.py \
309         lib/client/gnt_network.py \
310         lib/client/gnt_os.py \
311         lib/client/gnt_storage.py
312
313 cmdlib_PYTHON = \
314         lib/cmdlib/__init__.py \
315         lib/cmdlib/backup.py \
316         lib/cmdlib/base.py \
317         lib/cmdlib/cluster.py \
318         lib/cmdlib/common.py \
319         lib/cmdlib/group.py \
320         lib/cmdlib/instance.py \
321         lib/cmdlib/instance_migration.py \
322         lib/cmdlib/instance_operation.py \
323         lib/cmdlib/instance_query.py \
324         lib/cmdlib/instance_storage.py \
325         lib/cmdlib/instance_utils.py \
326         lib/cmdlib/misc.py \
327         lib/cmdlib/network.py \
328         lib/cmdlib/node.py \
329         lib/cmdlib/operating_system.py \
330         lib/cmdlib/query.py \
331         lib/cmdlib/tags.py \
332         lib/cmdlib/test.py
333
334 hypervisor_PYTHON = \
335         lib/hypervisor/__init__.py \
336         lib/hypervisor/hv_base.py \
337         lib/hypervisor/hv_chroot.py \
338         lib/hypervisor/hv_fake.py \
339         lib/hypervisor/hv_kvm.py \
340         lib/hypervisor/hv_lxc.py \
341         lib/hypervisor/hv_xen.py
342
343 rapi_PYTHON = \
344         lib/rapi/__init__.py \
345         lib/rapi/baserlib.py \
346         lib/rapi/client.py \
347         lib/rapi/client_utils.py \
348         lib/rapi/connector.py \
349         lib/rapi/rlib2.py \
350         lib/rapi/testutils.py
351
352 http_PYTHON = \
353         lib/http/__init__.py \
354         lib/http/auth.py \
355         lib/http/client.py \
356         lib/http/server.py
357
358 confd_PYTHON = \
359         lib/confd/__init__.py \
360         lib/confd/client.py
361
362 masterd_PYTHON = \
363         lib/masterd/__init__.py \
364         lib/masterd/iallocator.py \
365         lib/masterd/instance.py
366
367 impexpd_PYTHON = \
368         lib/impexpd/__init__.py
369
370 watcher_PYTHON = \
371         lib/watcher/__init__.py \
372         lib/watcher/nodemaint.py \
373         lib/watcher/state.py
374
375 server_PYTHON = \
376         lib/server/__init__.py \
377         lib/server/masterd.py \
378         lib/server/noded.py \
379         lib/server/rapi.py
380
381 pytools_PYTHON = \
382         lib/tools/__init__.py \
383         lib/tools/burnin.py \
384         lib/tools/ensure_dirs.py \
385         lib/tools/node_cleanup.py \
386         lib/tools/node_daemon_setup.py \
387         lib/tools/prepare_node_join.py
388
389 utils_PYTHON = \
390         lib/utils/__init__.py \
391         lib/utils/algo.py \
392         lib/utils/filelock.py \
393         lib/utils/hash.py \
394         lib/utils/io.py \
395         lib/utils/log.py \
396         lib/utils/lvm.py \
397         lib/utils/mlock.py \
398         lib/utils/nodesetup.py \
399         lib/utils/process.py \
400         lib/utils/retry.py \
401         lib/utils/text.py \
402         lib/utils/wrapper.py \
403         lib/utils/x509.py
404
405 docinput = \
406         doc/conf.py \
407         doc/css/style.css \
408         doc/admin.rst \
409         doc/cluster-merge.rst \
410         doc/design-2.0.rst \
411         doc/design-2.1.rst \
412         doc/design-2.2.rst \
413         doc/design-2.3.rst \
414         doc/design-2.4.rst \
415         doc/design-2.5.rst \
416         doc/design-2.6.rst \
417         doc/design-2.7.rst \
418         doc/design-2.8.rst \
419         doc/design-autorepair.rst \
420         doc/design-bulk-create.rst \
421         doc/design-chained-jobs.rst \
422         doc/design-cpu-pinning.rst \
423         doc/design-device-uuid-name.rst \
424         doc/design-draft.rst \
425         doc/design-htools-2.3.rst \
426         doc/design-http-server.rst \
427         doc/design-impexp2.rst \
428         doc/design-lu-generated-jobs.rst \
429         doc/design-linuxha.rst \
430         doc/design-multi-reloc.rst \
431         doc/design-network.rst \
432         doc/design-node-add.rst \
433         doc/design-oob.rst \
434         doc/design-ovf-support.rst \
435         doc/design-opportunistic-locking.rst \
436         doc/design-partitioned.rst \
437         doc/design-query-splitting.rst \
438         doc/design-query2.rst \
439         doc/design-reason-trail.rst \
440         doc/design-resource-model.rst \
441         doc/design-restricted-commands.rst \
442         doc/design-shared-storage.rst \
443         doc/design-monitoring-agent.rst \
444         doc/design-virtual-clusters.rst \
445         doc/design-x509-ca.rst \
446         doc/design-hroller.rst \
447         doc/design-storagetypes.rst \
448         doc/devnotes.rst \
449         doc/glossary.rst \
450         doc/hooks.rst \
451         doc/iallocator.rst \
452         doc/index.rst \
453         doc/install-quick.rst \
454         doc/install.rst \
455         doc/locking.rst \
456         doc/manpages-disabled.rst \
457         doc/move-instance.rst \
458         doc/news.rst \
459         doc/ovfconverter.rst \
460         doc/rapi.rst \
461         doc/security.rst \
462         doc/upgrade.rst \
463         doc/virtual-cluster.rst \
464         doc/walkthrough.rst
465
466 # Generates file names such as "doc/man-gnt-instance.rst"
467 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
468
469 # Haskell programs to be installed in $PREFIX/bin
470 HS_BIN_PROGS=src/htools
471
472 # Haskell programs to be installed in the MYEXECLIB dir
473 if ENABLE_MOND
474 HS_MYEXECLIB_PROGS=src/mon-collector
475 else
476 HS_MYEXECLIB_PROGS=
477 endif
478
479 # Haskell programs to be compiled by "make really-all"
480 HS_COMPILE_PROGS= \
481         src/ganeti-mond \
482         src/hconfd \
483         src/hluxid \
484         src/rpc-test
485
486 # All Haskell non-test programs to be compiled but not automatically installed
487 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
488
489 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
490 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
491
492 HS_ALL_PROGS = \
493         $(HS_PROGS) \
494         test/hs/hpc-htools \
495         test/hs/hpc-mon-collector \
496         test/hs/htest \
497         $(HS_COMPILE_PROGS)
498
499 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
500 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
501
502 HFLAGS = \
503         -O -Wall -Werror -isrc \
504         -fwarn-monomorphism-restriction \
505         -fwarn-tabs \
506         $(GHC_BYVERSION_FLAGS)
507
508 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
509 HEXTRA =
510 # internal extra flags (used for test/hs/htest mainly)
511 HEXTRA_INT =
512 # exclude options for coverage reports
513 HPCEXCL = --exclude Main \
514         --exclude Ganeti.Constants \
515         --exclude Ganeti.HTools.QC \
516         --exclude Ganeti.THH \
517         --exclude Ganeti.Version \
518         --exclude Test.Ganeti.Attoparsec \
519         --exclude Test.Ganeti.TestCommon \
520         --exclude Test.Ganeti.TestHTools \
521         --exclude Test.Ganeti.TestHelper \
522         --exclude Test.Ganeti.TestImports \
523         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
524
525 HS_LIB_SRCS = \
526         src/Ganeti/Block/Drbd/Types.hs \
527         src/Ganeti/Block/Drbd/Parser.hs \
528         src/Ganeti/BasicTypes.hs \
529         src/Ganeti/Common.hs \
530         src/Ganeti/Compat.hs \
531         src/Ganeti/Confd/Client.hs \
532         src/Ganeti/Confd/Server.hs \
533         src/Ganeti/Confd/Types.hs \
534         src/Ganeti/Confd/Utils.hs \
535         src/Ganeti/Config.hs \
536         src/Ganeti/ConfigReader.hs \
537         src/Ganeti/Curl/Multi.hs \
538         src/Ganeti/Daemon.hs \
539         src/Ganeti/DataCollectors/CLI.hs \
540         src/Ganeti/DataCollectors/Drbd.hs \
541         src/Ganeti/DataCollectors/Program.hs \
542         src/Ganeti/DataCollectors/Types.hs \
543         src/Ganeti/Errors.hs \
544         src/Ganeti/HTools/Backend/IAlloc.hs \
545         src/Ganeti/HTools/Backend/Luxi.hs \
546         src/Ganeti/HTools/Backend/Rapi.hs \
547         src/Ganeti/HTools/Backend/Simu.hs \
548         src/Ganeti/HTools/Backend/Text.hs \
549         src/Ganeti/HTools/CLI.hs \
550         src/Ganeti/HTools/Cluster.hs \
551         src/Ganeti/HTools/Container.hs \
552         src/Ganeti/HTools/ExtLoader.hs \
553         src/Ganeti/HTools/Graph.hs \
554         src/Ganeti/HTools/Group.hs \
555         src/Ganeti/HTools/Instance.hs \
556         src/Ganeti/HTools/Loader.hs \
557         src/Ganeti/HTools/Nic.hs \
558         src/Ganeti/HTools/Node.hs \
559         src/Ganeti/HTools/PeerMap.hs \
560         src/Ganeti/HTools/Program/Hail.hs \
561         src/Ganeti/HTools/Program/Harep.hs \
562         src/Ganeti/HTools/Program/Hbal.hs \
563         src/Ganeti/HTools/Program/Hcheck.hs \
564         src/Ganeti/HTools/Program/Hinfo.hs \
565         src/Ganeti/HTools/Program/Hscan.hs \
566         src/Ganeti/HTools/Program/Hspace.hs \
567         src/Ganeti/HTools/Program/Hroller.hs \
568         src/Ganeti/HTools/Program/Main.hs \
569         src/Ganeti/HTools/Types.hs \
570         src/Ganeti/Hypervisor/Xen/XmParser.hs \
571         src/Ganeti/Hypervisor/Xen/Types.hs \
572         src/Ganeti/Hash.hs \
573         src/Ganeti/JQueue.hs \
574         src/Ganeti/JSON.hs \
575         src/Ganeti/Jobs.hs \
576         src/Ganeti/Logging.hs \
577         src/Ganeti/Luxi.hs \
578         src/Ganeti/Monitoring/Server.hs \
579         src/Ganeti/Network.hs \
580         src/Ganeti/Objects.hs \
581         src/Ganeti/OpCodes.hs \
582         src/Ganeti/OpParams.hs \
583         src/Ganeti/Path.hs \
584         src/Ganeti/Query/Common.hs \
585         src/Ganeti/Query/Export.hs \
586         src/Ganeti/Query/Filter.hs \
587         src/Ganeti/Query/Group.hs \
588         src/Ganeti/Query/Job.hs \
589         src/Ganeti/Query/Language.hs \
590         src/Ganeti/Query/Network.hs \
591         src/Ganeti/Query/Node.hs \
592         src/Ganeti/Query/Query.hs \
593         src/Ganeti/Query/Server.hs \
594         src/Ganeti/Query/Types.hs \
595         src/Ganeti/Rpc.hs \
596         src/Ganeti/Runtime.hs \
597         src/Ganeti/Ssconf.hs \
598         src/Ganeti/THH.hs \
599         src/Ganeti/Types.hs \
600         src/Ganeti/Utils.hs
601
602 HS_TEST_SRCS = \
603         test/hs/Test/Ganeti/Attoparsec.hs \
604         test/hs/Test/Ganeti/BasicTypes.hs \
605         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
606         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
607         test/hs/Test/Ganeti/Common.hs \
608         test/hs/Test/Ganeti/Confd/Types.hs \
609         test/hs/Test/Ganeti/Confd/Utils.hs \
610         test/hs/Test/Ganeti/Daemon.hs \
611         test/hs/Test/Ganeti/Errors.hs \
612         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
613         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
614         test/hs/Test/Ganeti/HTools/CLI.hs \
615         test/hs/Test/Ganeti/HTools/Cluster.hs \
616         test/hs/Test/Ganeti/HTools/Container.hs \
617         test/hs/Test/Ganeti/HTools/Graph.hs \
618         test/hs/Test/Ganeti/HTools/Instance.hs \
619         test/hs/Test/Ganeti/HTools/Loader.hs \
620         test/hs/Test/Ganeti/HTools/Node.hs \
621         test/hs/Test/Ganeti/HTools/PeerMap.hs \
622         test/hs/Test/Ganeti/HTools/Types.hs \
623         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
624         test/hs/Test/Ganeti/JSON.hs \
625         test/hs/Test/Ganeti/Jobs.hs \
626         test/hs/Test/Ganeti/JQueue.hs \
627         test/hs/Test/Ganeti/Luxi.hs \
628         test/hs/Test/Ganeti/Network.hs \
629         test/hs/Test/Ganeti/Objects.hs \
630         test/hs/Test/Ganeti/OpCodes.hs \
631         test/hs/Test/Ganeti/Query/Filter.hs \
632         test/hs/Test/Ganeti/Query/Language.hs \
633         test/hs/Test/Ganeti/Query/Network.hs \
634         test/hs/Test/Ganeti/Query/Query.hs \
635         test/hs/Test/Ganeti/Rpc.hs \
636         test/hs/Test/Ganeti/Runtime.hs \
637         test/hs/Test/Ganeti/Ssconf.hs \
638         test/hs/Test/Ganeti/THH.hs \
639         test/hs/Test/Ganeti/TestCommon.hs \
640         test/hs/Test/Ganeti/TestHTools.hs \
641         test/hs/Test/Ganeti/TestHelper.hs \
642         test/hs/Test/Ganeti/Types.hs \
643         test/hs/Test/Ganeti/Utils.hs
644
645 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
646
647 HS_BUILT_SRCS = \
648         test/hs/Test/Ganeti/TestImports.hs \
649         src/Ganeti/Constants.hs \
650         src/Ganeti/Curl/Internal.hs \
651         src/Ganeti/Version.hs
652 HS_BUILT_SRCS_IN = \
653         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
654         src/Ganeti/Curl/Internal.hsc
655
656 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
657
658 $(RUN_IN_TEMPDIR): | stamp-directories
659
660 doc/html/index.html: ENABLE_MANPAGES =
661 doc/man-html/index.html: ENABLE_MANPAGES = 1
662 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
663
664 # Note: we use here an order-only prerequisite, as the contents of
665 # _autoconf.py are not actually influencing the html build output: it
666 # has to exist in order for the sphinx module to be loaded
667 # successfully, but we certainly don't want the docs to be rebuilt if
668 # it changes
669 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
670         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
671         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
672         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
673         | $(BUILT_PYTHON_SOURCES)
674         @test -n "$(SPHINX)" || \
675             { echo 'sphinx-build' not found during configure; exit 1; }
676 if !MANPAGES_IN_DOC
677         if test -n '$(ENABLE_MANPAGES)'; then \
678           echo 'Man pages in documentation were disabled at configure time' >&2; \
679           exit 1; \
680         fi
681 endif
682 ## Sphinx provides little control over what content should be included. Some
683 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
684 ## build two different versions of the documentation--once without man pages and
685 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
686 ## us with this, but requires running in a temporary directory. It moves the
687 ## correct files into place depending on environment variables.
688         dir=$(dir $@) && \
689         @mkdir_p@ $$dir && \
690         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
691         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
692             -d . \
693             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
694             -D release="$(PACKAGE_VERSION)" \
695             -D graphviz_dot="$(DOT)" \
696             -D enable_manpages="$(ENABLE_MANPAGES)" \
697             doc $(CURDIR)/$$dir && \
698         rm -f $$dir/.buildinfo $$dir/objects.inv
699         touch $@
700
701 doc/html: doc/html/index.html
702
703 doc/man-html: doc/man-html/index.html
704
705 doc/install-quick.rst: INSTALL
706 doc/news.rst: NEWS
707 doc/upgrade.rst: UPGRADE
708
709 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
710         set -e; \
711         { echo '.. This file is automatically updated at build time from $<.'; \
712           echo '.. Do not edit.'; \
713           echo; \
714           cat $<; \
715         } > $@
716
717 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
718         { echo '.. This file is automatically generated, do not edit!'; \
719           echo ''; \
720           echo 'Man pages'; \
721           echo '========='; \
722           echo; \
723           echo '.. toctree::'; \
724           echo '   :maxdepth: 1'; \
725           echo; \
726           for i in $(notdir $(mandocrst)); do \
727             echo "   $$i"; \
728           done | LC_ALL=C sort; \
729         } > $@
730
731 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
732 if MANPAGES_IN_DOC
733         { echo '.. This file is automatically updated at build time from $<.'; \
734           echo '.. Do not edit.'; \
735           echo; \
736           echo "$*"; \
737           echo '=========================================='; \
738           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
739         } > $@
740 else
741         echo 'Man pages in documentation were disabled at configure time' >&2; \
742         exit 1;
743 endif
744
745 # Things to build but not to install (add it to EXTRA_DIST if it should be
746 # distributed)
747 noinst_DATA = \
748         doc/html \
749         $(BUILT_EXAMPLES) \
750         doc/examples/bash_completion \
751         doc/examples/bash_completion-debug \
752         $(manhtml)
753
754 if MANPAGES_IN_DOC
755 noinst_DATA += doc/man-html
756 endif
757
758 gnt_scripts = \
759         scripts/gnt-backup \
760         scripts/gnt-cluster \
761         scripts/gnt-debug \
762         scripts/gnt-group \
763         scripts/gnt-instance \
764         scripts/gnt-job \
765         scripts/gnt-network \
766         scripts/gnt-node \
767         scripts/gnt-os \
768         scripts/gnt-storage
769
770 PYTHON_BOOTSTRAP_SBIN = \
771         daemons/ganeti-masterd \
772         daemons/ganeti-noded \
773         daemons/ganeti-rapi \
774         daemons/ganeti-watcher \
775         $(gnt_scripts)
776
777 PYTHON_BOOTSTRAP = \
778         $(PYTHON_BOOTSTRAP_SBIN) \
779         tools/burnin \
780         tools/ensure-dirs \
781         tools/node-cleanup \
782         tools/node-daemon-setup \
783         tools/prepare-node-join
784
785 qa_scripts = \
786         qa/__init__.py \
787         qa/ganeti-qa.py \
788         qa/qa_cluster.py \
789         qa/qa_config.py \
790         qa/qa_daemon.py \
791         qa/qa_env.py \
792         qa/qa_error.py \
793         qa/qa_group.py \
794         qa/qa_instance.py \
795         qa/qa_job.py \
796         qa/qa_node.py \
797         qa/qa_os.py \
798         qa/qa_rapi.py \
799         qa/qa_tags.py \
800         qa/qa_utils.py
801
802 bin_SCRIPTS =
803 if WANT_HTOOLS
804 bin_SCRIPTS += $(HS_BIN_PROGS)
805 install-exec-hook:
806         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
807 # FIXME: this is a hardcoded logic, instead of auto-resolving
808         $(LN_S) -f ../../../bin/htools \
809           $(DESTDIR)$(iallocatorsdir)/hail
810         for role in $(HS_BIN_ROLES); do \
811           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
812         done
813 endif
814
815 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
816         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
817           echo "Error: cannot run unittests without the development" \
818                " libraries (see devnotes.rst)" 1>&2; \
819           exit 1; \
820         fi
821         @rm -f $(notdir $@).tix
822         $(GHC) --make \
823           $(HFLAGS) \
824           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
825           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
826           $(HEXTRA) $(HEXTRA_INT) $@
827         @touch "$@"
828
829 # for the test/hs/htest binary, we need to enable profiling/coverage
830 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
831
832 # we compile the hpc-htools binary with the program coverage
833 test/hs/hpc-htools: HEXTRA_INT=-fhpc
834
835 # we compile the hpc-mon-collector binary with the program coverage
836 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
837
838 # test dependency
839 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
840
841 # rules for building profiling-enabled versions of the haskell
842 # programs: hs-prof does the full two-step build, whereas
843 # hs-prof-quick does only the final rebuild (hs-prof must have been
844 # run before)
845 .PHONY: hs-prof hs-prof-quick
846 hs-prof:
847         @if [ -z "$(TARGET)" ]; then \
848           echo "You need to define TARGET when running this rule" 1>&2; \
849           exit 1; \
850         fi
851         $(MAKE) $(AM_MAKEFLAGS) clean
852         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
853         rm -f $(HS_ALL_PROGS)
854         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
855
856 hs-prof-quick:
857         @if [ -z "$(TARGET)" ]; then \
858           echo "You need to define TARGET when running this rule" 1>&2; \
859           exit 1; \
860         fi
861         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
862
863 dist_sbin_SCRIPTS = \
864         tools/ganeti-listrunner
865
866 nodist_sbin_SCRIPTS = \
867         $(PYTHON_BOOTSTRAP_SBIN) \
868         daemons/ganeti-cleaner
869
870 if ENABLE_CONFD
871 src/ganeti-confd: src/hconfd
872         cp -f $< $@
873
874 src/ganeti-luxid: src/hluxid
875         cp -f $< $@
876
877 nodist_sbin_SCRIPTS += src/ganeti-confd
878 nodist_sbin_SCRIPTS += src/ganeti-luxid
879 endif
880
881 if ENABLE_MOND
882 nodist_sbin_SCRIPTS += src/ganeti-mond
883 endif
884
885 python_scripts = \
886         tools/cfgshell \
887         tools/cfgupgrade \
888         tools/cfgupgrade12 \
889         tools/cluster-merge \
890         tools/confd-client \
891         tools/fmtjson \
892         tools/lvmstrap \
893         tools/move-instance \
894         tools/ovfconverter \
895         tools/sanitize-config
896
897 dist_tools_SCRIPTS = \
898         $(python_scripts) \
899         tools/burnin \
900         tools/kvm-console-wrapper \
901         tools/master-ip-setup \
902         tools/xen-console-wrapper
903
904 nodist_tools_python_scripts = \
905         tools/node-cleanup
906
907 nodist_tools_SCRIPTS = \
908         $(nodist_tools_python_scripts) \
909         tools/users-setup \
910         tools/vcluster-setup
911
912 pkglib_python_scripts = \
913         daemons/import-export \
914         tools/check-cert-expired
915
916 nodist_pkglib_python_scripts = \
917         tools/ensure-dirs \
918         tools/node-daemon-setup \
919         tools/prepare-node-join
920
921 myexeclib_SCRIPTS = \
922         daemons/daemon-util \
923         tools/kvm-ifup \
924         $(pkglib_python_scripts) \
925         $(HS_MYEXECLIB_PROGS)
926
927 nodist_myexeclib_SCRIPTS = \
928         $(nodist_pkglib_python_scripts)
929
930 EXTRA_DIST = \
931         NEWS \
932         UPGRADE \
933         epydoc.conf.in \
934         pylintrc \
935         autotools/build-bash-completion \
936         autotools/build-rpc \
937         autotools/check-header \
938         autotools/check-imports \
939         autotools/check-man-dashes \
940         autotools/check-man-references \
941         autotools/check-man-warnings \
942         autotools/check-news \
943         autotools/check-python-code \
944         autotools/check-tar \
945         autotools/check-version \
946         autotools/convert-constants \
947         autotools/docpp \
948         autotools/gen-py-coverage \
949         autotools/sphinx-wrapper \
950         autotools/testrunner \
951         autotools/wrong-hardcoded-paths \
952         $(RUN_IN_TEMPDIR) \
953         daemons/daemon-util.in \
954         daemons/ganeti-cleaner.in \
955         $(pkglib_python_scripts) \
956         devel/upload \
957         devel/webserver \
958         tools/kvm-ifup.in \
959         tools/users-setup.in \
960         tools/vcluster-setup.in \
961         $(docinput) \
962         doc/html \
963         $(BUILT_EXAMPLES:%=%.in) \
964         doc/examples/ganeti.default \
965         doc/examples/ganeti.default-debug \
966         doc/examples/hooks/ethers \
967         doc/examples/gnt-debug/README \
968         doc/examples/gnt-debug/delay0.json \
969         doc/examples/gnt-debug/delay50.json \
970         test/py/lockperf.py \
971         test/py/testutils.py \
972         test/py/mocks.py \
973         $(dist_TESTS) \
974         $(TEST_FILES) \
975         man/footer.rst \
976         $(manrst) \
977         $(maninput) \
978         qa/qa-sample.json \
979         $(qa_scripts) \
980         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
981         $(HS_PROG_SRCS) \
982         src/lint-hints.hs \
983         test/hs/cli-tests-defs.sh \
984         test/hs/offline-test.sh \
985         .ghci
986
987 man_MANS = \
988         man/ganeti-cleaner.8 \
989         man/ganeti-confd.8 \
990         man/ganeti-luxid.8 \
991         man/ganeti-listrunner.8 \
992         man/ganeti-masterd.8 \
993         man/ganeti-mond.8 \
994         man/ganeti-noded.8 \
995         man/ganeti-os-interface.7 \
996         man/ganeti-extstorage-interface.7 \
997         man/ganeti-rapi.8 \
998         man/ganeti-watcher.8 \
999         man/ganeti.7 \
1000         man/gnt-backup.8 \
1001         man/gnt-cluster.8 \
1002         man/gnt-debug.8 \
1003         man/gnt-group.8 \
1004         man/gnt-network.8 \
1005         man/gnt-instance.8 \
1006         man/gnt-job.8 \
1007         man/gnt-node.8 \
1008         man/gnt-os.8 \
1009         man/gnt-storage.8 \
1010         man/hail.1 \
1011         man/harep.1 \
1012         man/hbal.1 \
1013         man/hcheck.1 \
1014         man/hinfo.1 \
1015         man/hscan.1 \
1016         man/hspace.1 \
1017         man/hroller.1 \
1018         man/htools.1 \
1019         man/mon-collector.7
1020
1021 # Remove extensions from all filenames in man_MANS
1022 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1023
1024 manrst = $(patsubst %,%.rst,$(mannoext))
1025 manhtml = $(patsubst %.rst,%.html,$(manrst))
1026 mangen = $(patsubst %.rst,%.gen,$(manrst))
1027 maninput = \
1028         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1029         $(patsubst %.html,%.html.in,$(manhtml)) \
1030         $(mangen)
1031
1032 TEST_FILES = \
1033         test/autotools/autotools-check-news.test \
1034         test/data/htools/clean-nonzero-score.data \
1035         test/data/htools/common-suffix.data \
1036         test/data/htools/empty-cluster.data \
1037         test/data/htools/hail-alloc-drbd.json \
1038         test/data/htools/hail-alloc-invalid-network.json \
1039         test/data/htools/hail-alloc-invalid-twodisks.json \
1040         test/data/htools/hail-alloc-restricted-network.json \
1041         test/data/htools/hail-alloc-twodisks.json \
1042         test/data/htools/hail-change-group.json \
1043         test/data/htools/hail-invalid-reloc.json \
1044         test/data/htools/hail-node-evac.json \
1045         test/data/htools/hail-reloc-drbd.json \
1046         test/data/htools/hbal-excl-tags.data \
1047         test/data/htools/hbal-split-insts.data \
1048         test/data/htools/hspace-tiered-dualspec.data \
1049         test/data/htools/hspace-tiered-ipolicy.data \
1050         test/data/htools/hspace-tiered-resourcetypes.data \
1051         test/data/htools/hspace-tiered.data \
1052         test/data/htools/invalid-node.data \
1053         test/data/htools/missing-resources.data \
1054         test/data/htools/multiple-master.data \
1055         test/data/htools/n1-failure.data \
1056         test/data/htools/rapi/groups.json \
1057         test/data/htools/rapi/info.json \
1058         test/data/htools/rapi/instances.json \
1059         test/data/htools/rapi/nodes.json \
1060         test/data/htools/unique-reboot-order.data \
1061         test/hs/shelltests/htools-balancing.test \
1062         test/hs/shelltests/htools-basic.test \
1063         test/hs/shelltests/htools-dynutil.test \
1064         test/hs/shelltests/htools-excl.test \
1065         test/hs/shelltests/htools-hail.test \
1066         test/hs/shelltests/htools-hroller.test \
1067         test/hs/shelltests/htools-hspace.test \
1068         test/hs/shelltests/htools-invalid.test \
1069         test/hs/shelltests/htools-multi-group.test \
1070         test/hs/shelltests/htools-no-backend.test \
1071         test/hs/shelltests/htools-rapi.test \
1072         test/hs/shelltests/htools-single-group.test \
1073         test/hs/shelltests/htools-text-backend.test \
1074         test/hs/shelltests/htools-mon-collector.test \
1075         test/data/bdev-drbd-8.0.txt \
1076         test/data/bdev-drbd-8.3.txt \
1077         test/data/bdev-drbd-disk.txt \
1078         test/data/bdev-drbd-net-ip4.txt \
1079         test/data/bdev-drbd-net-ip6.txt \
1080         test/data/bdev-rbd/json_output_empty.txt \
1081         test/data/bdev-rbd/json_output_extra_matches.txt \
1082         test/data/bdev-rbd/json_output_no_matches.txt \
1083         test/data/bdev-rbd/json_output_ok.txt \
1084         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1085         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1086         test/data/bdev-rbd/plain_output_new_ok.txt \
1087         test/data/bdev-rbd/plain_output_old_empty.txt \
1088         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1089         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1090         test/data/bdev-rbd/plain_output_old_ok.txt \
1091         test/data/bdev-rbd/output_invalid.txt \
1092         test/data/cert1.pem \
1093         test/data/cert2.pem \
1094         test/data/cluster_config_2.7.json \
1095         test/data/cluster_config_downgraded_2.7.json \
1096         test/data/instance-minor-pairing.txt \
1097         test/data/ip-addr-show-dummy0.txt \
1098         test/data/ip-addr-show-lo-ipv4.txt \
1099         test/data/ip-addr-show-lo-ipv6.txt \
1100         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1101         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1102         test/data/ip-addr-show-lo-oneline.txt \
1103         test/data/ip-addr-show-lo.txt \
1104         test/data/kvm_0.12.5_help.txt \
1105         test/data/kvm_0.15.90_help.txt \
1106         test/data/kvm_0.9.1_help.txt \
1107         test/data/kvm_0.9.1_help_boot_test.txt \
1108         test/data/kvm_1.0_help.txt \
1109         test/data/kvm_1.1.2_help.txt \
1110         test/data/NEWS_OK.txt \
1111         test/data/NEWS_previous_unreleased.txt \
1112         test/data/ovfdata/compr_disk.vmdk.gz \
1113         test/data/ovfdata/config.ini \
1114         test/data/ovfdata/corrupted_resources.ovf \
1115         test/data/ovfdata/empty.ini \
1116         test/data/ovfdata/empty.ovf \
1117         test/data/ovfdata/ganeti.mf \
1118         test/data/ovfdata/ganeti.ovf \
1119         test/data/ovfdata/gzip_disk.ovf \
1120         test/data/ovfdata/new_disk.vmdk \
1121         test/data/ovfdata/no_disk.ini \
1122         test/data/ovfdata/no_disk_in_ref.ovf \
1123         test/data/ovfdata/no_os.ini \
1124         test/data/ovfdata/no_ovf.ova \
1125         test/data/ovfdata/other/rawdisk.raw \
1126         test/data/ovfdata/ova.ova \
1127         test/data/ovfdata/rawdisk.raw \
1128         test/data/ovfdata/second_disk.vmdk \
1129         test/data/ovfdata/unsafe_path.ini \
1130         test/data/ovfdata/virtualbox.ovf \
1131         test/data/ovfdata/wrong_config.ini \
1132         test/data/ovfdata/wrong_extension.ovd \
1133         test/data/ovfdata/wrong_manifest.mf \
1134         test/data/ovfdata/wrong_manifest.ovf \
1135         test/data/ovfdata/wrong_ova.ova \
1136         test/data/ovfdata/wrong_xml.ovf \
1137         test/data/proc_drbd8.txt \
1138         test/data/proc_drbd80-emptyline.txt \
1139         test/data/proc_drbd83.txt \
1140         test/data/proc_drbd83_sync.txt \
1141         test/data/proc_drbd83_sync_want.txt \
1142         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1143         test/data/qa-minimal-nodes-instances-only.json \
1144         test/data/sys_drbd_usermode_helper.txt \
1145         test/data/vgreduce-removemissing-2.02.02.txt \
1146         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1147         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1148         test/data/vgs-missing-pvs-2.02.02.txt \
1149         test/data/vgs-missing-pvs-2.02.66.txt \
1150         test/data/xen-xm-info-4.0.1.txt \
1151         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1152         test/data/xen-xm-list-4.0.1-four-instances.txt \
1153         test/data/xen-xm-list-long-4.0.1.txt \
1154         test/data/xen-xm-uptime-4.0.1.txt \
1155         test/py/ganeti-cli.test \
1156         test/py/gnt-cli.test \
1157         test/py/import-export_unittest-helper
1158
1159
1160 python_tests = \
1161         doc/examples/rapi_testutils.py \
1162         test/py/cfgupgrade_unittest.py \
1163         test/py/docs_unittest.py \
1164         test/py/ganeti.asyncnotifier_unittest.py \
1165         test/py/ganeti.backend_unittest-runasroot.py \
1166         test/py/ganeti.backend_unittest.py \
1167         test/py/ganeti.bdev_unittest.py \
1168         test/py/ganeti.cli_unittest.py \
1169         test/py/ganeti.client.gnt_cluster_unittest.py \
1170         test/py/ganeti.client.gnt_instance_unittest.py \
1171         test/py/ganeti.client.gnt_job_unittest.py \
1172         test/py/ganeti.cmdlib_unittest.py \
1173         test/py/ganeti.compat_unittest.py \
1174         test/py/ganeti.confd.client_unittest.py \
1175         test/py/ganeti.config_unittest.py \
1176         test/py/ganeti.constants_unittest.py \
1177         test/py/ganeti.daemon_unittest.py \
1178         test/py/ganeti.errors_unittest.py \
1179         test/py/ganeti.hooks_unittest.py \
1180         test/py/ganeti.ht_unittest.py \
1181         test/py/ganeti.http_unittest.py \
1182         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1183         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1184         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1185         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1186         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1187         test/py/ganeti.hypervisor_unittest.py \
1188         test/py/ganeti.impexpd_unittest.py \
1189         test/py/ganeti.jqueue_unittest.py \
1190         test/py/ganeti.jstore_unittest.py \
1191         test/py/ganeti.locking_unittest.py \
1192         test/py/ganeti.luxi_unittest.py \
1193         test/py/ganeti.masterd.iallocator_unittest.py \
1194         test/py/ganeti.masterd.instance_unittest.py \
1195         test/py/ganeti.mcpu_unittest.py \
1196         test/py/ganeti.netutils_unittest.py \
1197         test/py/ganeti.objects_unittest.py \
1198         test/py/ganeti.opcodes_unittest.py \
1199         test/py/ganeti.outils_unittest.py \
1200         test/py/ganeti.ovf_unittest.py \
1201         test/py/ganeti.qlang_unittest.py \
1202         test/py/ganeti.query_unittest.py \
1203         test/py/ganeti.rapi.baserlib_unittest.py \
1204         test/py/ganeti.rapi.client_unittest.py \
1205         test/py/ganeti.rapi.resources_unittest.py \
1206         test/py/ganeti.rapi.rlib2_unittest.py \
1207         test/py/ganeti.rapi.testutils_unittest.py \
1208         test/py/ganeti.rpc_unittest.py \
1209         test/py/ganeti.runtime_unittest.py \
1210         test/py/ganeti.serializer_unittest.py \
1211         test/py/ganeti.server.rapi_unittest.py \
1212         test/py/ganeti.ssconf_unittest.py \
1213         test/py/ganeti.ssh_unittest.py \
1214         test/py/ganeti.storage_unittest.py \
1215         test/py/ganeti.tools.burnin_unittest.py \
1216         test/py/ganeti.tools.ensure_dirs_unittest.py \
1217         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1218         test/py/ganeti.tools.prepare_node_join_unittest.py \
1219         test/py/ganeti.uidpool_unittest.py \
1220         test/py/ganeti.utils.algo_unittest.py \
1221         test/py/ganeti.utils.filelock_unittest.py \
1222         test/py/ganeti.utils.hash_unittest.py \
1223         test/py/ganeti.utils.io_unittest-runasroot.py \
1224         test/py/ganeti.utils.io_unittest.py \
1225         test/py/ganeti.utils.log_unittest.py \
1226         test/py/ganeti.utils.lvm_unittest.py \
1227         test/py/ganeti.utils.mlock_unittest.py \
1228         test/py/ganeti.utils.nodesetup_unittest.py \
1229         test/py/ganeti.utils.process_unittest.py \
1230         test/py/ganeti.utils.retry_unittest.py \
1231         test/py/ganeti.utils.text_unittest.py \
1232         test/py/ganeti.utils.wrapper_unittest.py \
1233         test/py/ganeti.utils.x509_unittest.py \
1234         test/py/ganeti.utils_unittest.py \
1235         test/py/ganeti.vcluster_unittest.py \
1236         test/py/ganeti.workerpool_unittest.py \
1237         test/py/pycurl_reset_unittest.py \
1238         test/py/qa.qa_config_unittest.py \
1239         test/py/tempfile_fork_unittest.py
1240
1241 haskell_tests = test/hs/htest
1242
1243 dist_TESTS = \
1244         test/py/check-cert-expired_unittest.bash \
1245         test/py/daemon-util_unittest.bash \
1246         test/py/ganeti-cleaner_unittest.bash \
1247         test/py/import-export_unittest.bash \
1248         test/py/cli-test.bash \
1249         test/py/bash_completion.bash
1250
1251 if PY_UNIT
1252 dist_TESTS += $(python_tests)
1253 endif
1254
1255 nodist_TESTS =
1256 check_SCRIPTS =
1257
1258 if WANT_HSTESTS
1259 nodist_TESTS += $(haskell_tests)
1260 dist_TESTS += test/hs/offline-test.sh
1261 check_SCRIPTS += \
1262         test/hs/hpc-htools \
1263         test/hs/hpc-mon-collector \
1264         $(HS_BUILT_TEST_HELPERS)
1265 endif
1266
1267 TESTS = $(dist_TESTS) $(nodist_TESTS)
1268
1269 # Environment for all tests
1270 PLAIN_TESTS_ENVIRONMENT = \
1271         PYTHONPATH=. \
1272         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1273         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1274         $(RUN_IN_TEMPDIR)
1275
1276 # Environment for tests run by automake
1277 TESTS_ENVIRONMENT = \
1278         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1279
1280 all_python_code = \
1281         $(dist_sbin_SCRIPTS) \
1282         $(python_scripts) \
1283         $(pkglib_python_scripts) \
1284         $(nodist_pkglib_python_scripts) \
1285         $(nodist_tools_python_scripts) \
1286         $(pkgpython_PYTHON) \
1287         $(client_PYTHON) \
1288         $(cmdlib_PYTHON) \
1289         $(hypervisor_PYTHON) \
1290         $(rapi_PYTHON) \
1291         $(server_PYTHON) \
1292         $(pytools_PYTHON) \
1293         $(http_PYTHON) \
1294         $(confd_PYTHON) \
1295         $(masterd_PYTHON) \
1296         $(impexpd_PYTHON) \
1297         $(utils_PYTHON) \
1298         $(watcher_PYTHON) \
1299         $(noinst_PYTHON) \
1300         $(qa_scripts)
1301
1302 if PY_UNIT
1303 all_python_code += $(python_tests)
1304 endif
1305
1306 srclink_files = \
1307         man/footer.rst \
1308         test/py/check-cert-expired_unittest.bash \
1309         test/py/daemon-util_unittest.bash \
1310         test/py/ganeti-cleaner_unittest.bash \
1311         test/py/import-export_unittest.bash \
1312         test/py/cli-test.bash \
1313         test/py/bash_completion.bash \
1314         test/hs/offline-test.sh \
1315         test/hs/cli-tests-defs.sh \
1316         $(all_python_code) \
1317         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1318         $(docinput)
1319
1320 check_python_code = \
1321         $(BUILD_BASH_COMPLETION) \
1322         $(CHECK_IMPORTS) \
1323         $(CHECK_HEADER) \
1324         $(DOCPP) \
1325         $(all_python_code)
1326
1327 lint_python_code = \
1328         ganeti \
1329         ganeti/http/server.py \
1330         $(dist_sbin_SCRIPTS) \
1331         $(python_scripts) \
1332         $(pkglib_python_scripts) \
1333         $(BUILD_BASH_COMPLETION) \
1334         $(CHECK_IMPORTS) \
1335         $(CHECK_HEADER) \
1336         $(DOCPP) \
1337         $(PYTHON_BOOTSTRAP)
1338
1339 standalone_python_modules = \
1340         lib/rapi/client.py \
1341         tools/ganeti-listrunner
1342
1343 pep8_python_code = \
1344         ganeti \
1345         ganeti/http/server.py \
1346         $(dist_sbin_SCRIPTS) \
1347         $(python_scripts) \
1348         $(pkglib_python_scripts) \
1349         $(BUILD_BASH_COMPLETION) \
1350         $(CHECK_HEADER) \
1351         $(DOCPP) \
1352         $(PYTHON_BOOTSTRAP) \
1353         qa
1354
1355 test/py/daemon-util_unittest.bash: daemons/daemon-util
1356
1357 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1358
1359 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1360
1361 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1362         sed -f $(REPLACE_VARS_SED) < $< > $@
1363         chmod +x $@
1364
1365 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1366         sed -f $(REPLACE_VARS_SED) < $< > $@
1367         chmod +x $@
1368
1369 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1370         sed -f $(REPLACE_VARS_SED) < $< > $@
1371         chmod +x $@
1372
1373 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1374         sed -f $(REPLACE_VARS_SED) < $< > $@
1375         chmod +x $@
1376
1377 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1378         sed -f $(REPLACE_VARS_SED) < $< > $@
1379
1380 doc/examples/bash_completion: BC_ARGS = --compact
1381 doc/examples/bash_completion-debug: BC_ARGS =
1382
1383 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1384         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1385         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1386         daemons/ganeti-cleaner \
1387         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1388         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1389           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1390
1391 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1392         lib/build/shell_example_lexer.py \
1393         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1394         @echo "Checking $< for hardcoded paths..."
1395         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1396           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1397           exit 1; \
1398         fi
1399         set -e ; \
1400         trap 'echo auto-removing $@; rm $@' EXIT; \
1401         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1402         $(CHECK_MAN_REFERENCES) $@; \
1403         trap - EXIT
1404
1405 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1406         @test -n "$(PANDOC)" || \
1407           { echo 'pandoc' not found during configure; exit 1; }
1408         set -o pipefail -e; \
1409         trap 'echo auto-removing $@; rm $@' EXIT; \
1410         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1411           sed -e 's/\\@/@/g' > $@; \
1412         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1413         $(CHECK_MAN_DASHES) $@; \
1414         trap - EXIT
1415
1416 man/%.html.in: man/%.gen man/footer.rst
1417         @test -n "$(PANDOC)" || \
1418           { echo 'pandoc' not found during configure; exit 1; }
1419         set -o pipefail ; \
1420         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1421           sed -e 's/\\@/@/g' > $@
1422
1423 man/%: man/%.in  $(REPLACE_VARS_SED)
1424         sed -f $(REPLACE_VARS_SED) < $< > $@
1425
1426 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1427         sed -f $(REPLACE_VARS_SED) < $< > $@
1428
1429 vcs-version:
1430         if test -d .git; then \
1431           git describe > $@; \
1432         elif test ! -f $@ ; then \
1433           echo "Cannot auto-generate $@ file"; exit 1; \
1434         fi
1435
1436 .PHONY: clean-vcs-version
1437 clean-vcs-version:
1438         rm -f vcs-version
1439
1440 .PHONY: regen-vcs-version
1441 regen-vcs-version:
1442         @set -e; \
1443         cd $(srcdir); \
1444         if test -d .git; then \
1445           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1446           git describe > $$T; \
1447           if ! cmp --quiet $$T vcs-version; then \
1448             mv $$T vcs-version; \
1449           fi; \
1450         fi
1451
1452 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1453         vcs-version $(built_base_sources)
1454         set -e; \
1455         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1456         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1457
1458 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1459         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1460         lib/jstore.py $(RUN_IN_TEMPDIR) \
1461         $(CONVERT_CONSTANTS) $(built_base_sources) \
1462         | lib/_vcsversion.py
1463         set -e; \
1464         { cat $< ; \
1465           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1466         } > $@
1467
1468 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1469         hsc2hs -o $@ $<
1470
1471 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1472         $(built_base_sources)
1473         set -e; \
1474         { cat $< ; \
1475           echo ; \
1476           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1477             echo "import $$name ()" ; \
1478           done ; \
1479         } > $@
1480
1481 lib/_autoconf.py: Makefile | stamp-directories
1482         set -e; \
1483         { echo '# This file is automatically generated, do not edit!'; \
1484           echo '#'; \
1485           echo ''; \
1486           echo '"""Build-time configuration for Ganeti.'; \
1487           echo '';\
1488           echo 'This file is autogenerated by the build process.'; \
1489           echo 'For any changes you need to re-run ./configure (and'; \
1490           echo 'not edit by hand).'; \
1491           echo ''; \
1492           echo '"""'; \
1493           echo ''; \
1494           echo '# pylint: disable=C0301,C0324'; \
1495           echo '# because this is autogenerated, we do not want'; \
1496           echo '# style warnings' ; \
1497           echo ''; \
1498           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1499           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1500           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1501           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1502           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1503           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1504           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1505           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1506           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1507           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1508           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1509           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1510           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1511           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1512           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1513           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1514           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1515           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1516           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1517           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1518           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1519           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1520           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1521           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1522           echo "KVM_PATH = '$(KVM_PATH)'"; \
1523           echo "IP_PATH = '$(IP_PATH)'"; \
1524           echo "SOCAT_PATH = '$(SOCAT)'"; \
1525           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1526           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1527           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1528           echo "TOOLSDIR = '$(toolsdir)'"; \
1529           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1530           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1531           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1532           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1533           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1534           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1535           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1536           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1537           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1538           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1539           echo "RAPI_USER = '$(RAPI_USER)'"; \
1540           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1541           echo "CONFD_USER = '$(CONFD_USER)'"; \
1542           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1543           echo "LUXID_USER = '$(LUXID_USER)'"; \
1544           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1545           echo "NODED_USER = '$(NODED_USER)'"; \
1546           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1547           echo "MOND_USER = '$(MOND_USER)'"; \
1548           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1549           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1550           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1551           echo "HTOOLS = True"; \
1552           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1553           echo "XEN_CMD = '$(XEN_CMD)'"; \
1554           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1555           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1556           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1557 ## Write dictionary with man page name as the key and the section number as the
1558 ## value
1559           echo "MAN_PAGES = {"; \
1560           for i in $(notdir $(man_MANS)); do \
1561             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1562           done; \
1563           echo "}"; \
1564         } > $@
1565
1566 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1567         set -e; \
1568         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1569         { echo '# This file is automatically generated, do not edit!'; \
1570           echo '#'; \
1571           echo ''; \
1572           echo '"""Build-time VCS version number for Ganeti.'; \
1573           echo '';\
1574           echo 'This file is autogenerated by the build process.'; \
1575           echo 'For any changes you need to re-run ./configure (and'; \
1576           echo 'not edit by hand).'; \
1577           echo ''; \
1578           echo '"""'; \
1579           echo ''; \
1580           echo '# pylint: disable=C0301,C0324'; \
1581           echo '# because this is autogenerated, we do not want'; \
1582           echo '# style warnings' ; \
1583           echo ''; \
1584           echo "VCS_VERSION = '$$VCSVER'"; \
1585         } > $@
1586
1587 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1588         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1589
1590 $(SHELL_ENV_INIT): Makefile stamp-directories
1591         set -e; \
1592         { echo '# Allow overriding for tests'; \
1593           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1594           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1595           echo; \
1596           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1597           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1598           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1599           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1600           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1601         } > $@
1602
1603 ## Writes sed script to replace placeholders with build-time values. The
1604 ## additional quotes after the first @ sign are necessary to stop configure
1605 ## from replacing those values as well.
1606 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1607         set -e; \
1608         { echo 's#@''PREFIX@#$(prefix)#g'; \
1609           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1610           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1611           echo 's#@''BINDIR@#$(bindir)#g'; \
1612           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1613           echo 's#@''LIBDIR@#$(libdir)#g'; \
1614           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1615           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1616           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1617           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1618           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1619           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1620           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1621           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1622           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1623           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1624           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1625           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1626           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1627           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1628           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1629           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1630           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1631           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1632           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1633           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1634           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1635           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1636           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1637           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1638           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1639           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1640           echo; \
1641           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1642           echo '  r $(SHELL_ENV_INIT)'; \
1643           echo '  d'; \
1644           echo '}'; \
1645         } > $@
1646
1647 # Using deferred evaluation
1648 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1649 daemons/ganeti-watcher: MODULE = ganeti.watcher
1650 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1651 tools/burnin: MODULE = ganeti.tools.burnin
1652 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1653 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1654 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1655 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1656 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1657
1658 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1659         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1660         set -e; \
1661         { echo '#!/usr/bin/python'; \
1662           echo '# This file is automatically generated, do not edit!'; \
1663           echo "# Edit $(MODULE) instead."; \
1664           echo; \
1665           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1666           echo; \
1667           echo '# pylint: disable=C0103'; \
1668           echo '# C0103: Invalid name'; \
1669           echo; \
1670           echo 'import sys'; \
1671           echo 'import $(MODULE) as main'; \
1672           echo; \
1673           echo '# Temporarily alias commands until bash completion'; \
1674           echo '# generator is changed'; \
1675           echo 'if hasattr(main, "commands"):'; \
1676           echo '  commands = main.commands # pylint: disable=E1101'; \
1677           echo 'if hasattr(main, "aliases"):'; \
1678           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1679           echo; \
1680           echo 'if __name__ == "__main__":'; \
1681           echo '  sys.exit(main.Main())'; \
1682         } > $@
1683         chmod u+x $@
1684
1685 $(HS_BUILT_TEST_HELPERS): Makefile
1686         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1687         set -e; \
1688         { echo '#!/bin/sh'; \
1689           echo '# This file is automatically generated, do not edit!'; \
1690           echo "# Edit Makefile.am instead."; \
1691           echo; \
1692           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1693         } > $@
1694         chmod u+x $@
1695
1696 stamp-directories: Makefile
1697         $(MAKE) $(AM_MAKEFLAGS) ganeti
1698         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1699         touch $@
1700
1701 # We need to create symlinks because "make distcheck" will not install Python
1702 # files when building.
1703 stamp-srclinks: Makefile | stamp-directories
1704         set -e; \
1705         for i in $(srclink_files); do \
1706           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1707             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1708           fi; \
1709         done
1710         touch $@
1711
1712 .PHONY: ganeti
1713 ganeti:
1714         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1715
1716 .PHONY: check-dirs
1717 check-dirs: $(GENERATED_FILES)
1718         @set -e; \
1719         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1720           error=; \
1721           while read dir; do \
1722             case "$$dir" in \
1723               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1724               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1725             esac; \
1726           done; \
1727           for dir in $(DIRS); do \
1728             if ! test -d "$$dir"; then \
1729               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1730               error=1; \
1731             fi \
1732           done; \
1733           test -z "$$error"; \
1734         }
1735
1736 .PHONY: check-local
1737 check-local: check-dirs $(GENERATED_FILES)
1738         $(CHECK_PYTHON_CODE) $(check_python_code)
1739         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1740         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1741         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1742         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1743         error= ; \
1744         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1745           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1746           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1747             echo "Incorrect version in README, expected $$expver" >&2; \
1748             error=1; \
1749           fi; \
1750           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1751               doc/security.rst; do \
1752             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1753               "Documents Ganeti version $$expver"; then \
1754               echo "Incorrect version in $$file, expected $$expver" >&2; \
1755               error=1; \
1756             fi; \
1757           done; \
1758           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1759             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1760             error=1; \
1761           fi; \
1762           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1763             ".. Last updated for Ganeti $$expver"; then \
1764             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1765             error=1; \
1766           fi; \
1767         fi; \
1768         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1769           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1770             echo "Longest line in $$file is longer than 80 characters" >&2; \
1771             error=1; \
1772           fi; \
1773         done; \
1774         test -z "$$error"
1775
1776 .PHONY: hs-tests
1777 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1778         @rm -f htest.tix
1779         ./test/hs/htest
1780
1781 .PHONY: hs-shell
1782 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1783         @rm -f hpc-htools.tix hpc-mon-collector.tix
1784         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1785
1786 .PHONY: hs-check
1787 hs-check: hs-tests hs-shell
1788
1789 # E111: indentation is not a multiple of four
1790 # E121: continuation line indentation is not a multiple of four
1791 #       (since our indent level is not 4)
1792 # E125: continuation line does not distinguish itself from next logical line
1793 #       (since our indent level is not 4)
1794 # E127: continuation line over-indented for visual indent
1795 #       (since our indent level is not 4)
1796 # note: do NOT add E128 here; it's a valid style error in most cases!
1797 # I've seen real errors, but also some cases were we indent wrongly
1798 # due to line length; try to rework the cases where it is triggered,
1799 # instead of silencing it
1800 # E261: at least two spaces before inline comment
1801 # E501: line too long (80 characters)
1802 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1803
1804 # For excluding pep8 expects filenames only, not whole paths
1805 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1806
1807 LINT_TARGETS = pylint pylint-qa
1808 if HAS_PEP8
1809 LINT_TARGETS += pep8
1810 endif
1811 if HAS_HLINT
1812 LINT_TARGETS += hlint
1813 endif
1814
1815 .PHONY: lint
1816 lint: $(LINT_TARGETS)
1817
1818 .PHONY: pylint
1819 pylint: $(GENERATED_FILES)
1820         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1821         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1822
1823 .PHONY: pylint-qa
1824 pylint-qa: $(GENERATED_FILES)
1825         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1826         cd $(top_srcdir)/qa && \
1827           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1828           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1829
1830 .PHONY: pep8
1831 pep8: $(GENERATED_FILES)
1832         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1833         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1834           --repeat $(pep8_python_code)
1835
1836 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1837 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1838 .PHONY: hlint
1839 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1840         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1841         @rm -f doc/hs-lint.html
1842         if tty -s; then C="-c"; else C=""; fi; \
1843         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1844           --ignore "Use first" \
1845           --ignore "Use &&&" \
1846           --ignore "Use void" \
1847           --ignore "Reduce duplication" \
1848           --hint src/lint-hints \
1849           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1850         @if [ ! -f doc/hs-lint.html ]; then \
1851           echo "All good" > doc/hs-lint.html; \
1852         fi
1853
1854 # a dist hook rule for updating the vcs-version file; this is
1855 # hardcoded due to where it needs to build the file...
1856 dist-hook:
1857         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1858         rm -f $(top_distdir)/vcs-version
1859         cp -p $(srcdir)/vcs-version $(top_distdir)
1860
1861 # a distcheck hook rule for catching revision control directories
1862 distcheck-hook:
1863         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1864           echo "Found revision control files in final archive." 1>&2; \
1865           exit 1; \
1866         fi
1867         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1868           echo "Found Python byte code in final archive." 1>&2; \
1869           exit 1; \
1870         fi
1871         if find $(top_distdir) -name '*~' | grep .; then \
1872           echo "Found backup files in final archive." 1>&2; \
1873           exit 1; \
1874         fi
1875 # Empty files or directories should not be distributed. They can cause
1876 # unnecessary warnings for packagers. Directories used by automake during
1877 # distcheck must be excluded.
1878         if find $(top_distdir) -empty -and -not \( \
1879             -path $(top_distdir)/_build -or \
1880             -path $(top_distdir)/_inst \) | grep .; then \
1881           echo "Found empty files or directories in final archive." 1>&2; \
1882           exit 1; \
1883         fi
1884         if test -e $(top_distdir)/doc/man-html; then \
1885           echo "Found documentation including man pages in final archive" >&2; \
1886           exit 1; \
1887         fi
1888
1889 # Backwards compatible distcheck-release target
1890 distcheck-release: distcheck
1891
1892 distrebuildcheck: dist
1893         set -e; \
1894         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1895         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1896         cd $$builddir; \
1897         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1898         cd $(distdir); \
1899         ./configure; \
1900         $(MAKE) maintainer-clean; \
1901         cp $(abs_srcdir)/vcs-version .; \
1902         ./configure; \
1903         $(MAKE) $(AM_MAKEFLAGS)
1904
1905 dist-release: dist
1906         set -e; \
1907         for i in $(DIST_ARCHIVES); do \
1908           echo -n "Checking $$i ... "; \
1909           autotools/check-tar < $$i; \
1910           echo OK; \
1911         done
1912
1913 install-exec-local:
1914         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1915           "$(DESTDIR)${localstatedir}/log/ganeti" \
1916           "$(DESTDIR)${localstatedir}/run/ganeti"
1917
1918 .PHONY: apidoc
1919 if WANT_HSAPIDOC
1920 apidoc: py-apidoc hs-apidoc
1921 else
1922 apidoc: py-apidoc
1923 endif
1924
1925 .PHONY: py-apidoc
1926 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1927         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1928         $(RUN_IN_TEMPDIR) epydoc -v \
1929           --conf $(CURDIR)/epydoc.conf \
1930           --output $(CURDIR)/$(APIDOC_PY_DIR)
1931
1932 .PHONY: hs-apidoc
1933 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1934
1935 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1936         @test -n "$(HSCOLOUR)" || \
1937             { echo 'HsColour' not found during configure; exit 1; }
1938         @test -n "$(HADDOCK)" || \
1939             { echo 'haddock' not found during configure; exit 1; }
1940         rm -rf $(APIDOC_HS_DIR)/*
1941         for i in $(ALL_APIDOC_HS_DIRS); do \
1942           @mkdir_p@ $$i; \
1943           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1944         done
1945         set -e ; \
1946         export LC_ALL=en_US.UTF-8; \
1947         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1948         if [ "$(HS_PARALLEL3)" ]; \
1949         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1950         fi; \
1951         if [ "$(HS_REGEX_PCRE)" ]; \
1952         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1953         fi; \
1954         for file in $(HS_LIBTESTBUILT_SRCS); do \
1955           f_nosrc=$${file##src/}; \
1956           f_notst=$${f_nosrc##test/hs/}; \
1957           f_html=$${f_notst%%.hs}.html; \
1958           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1959         done ; \
1960         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1961           -t ganeti -p src/haddock-prologue \
1962           --source-module="%{MODULE/.//}.html" \
1963           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1964           $$OPTGHC \
1965           $(HS_LIBTESTBUILT_SRCS)
1966
1967 .PHONY: TAGS
1968 TAGS: $(GENERATED_FILES)
1969         rm -f TAGS
1970         $(GHC) -e ":etags" -v0 \
1971           $(filter-out -O -Werror,$(HFLAGS)) \
1972           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1973           $(HS_LIBTEST_SRCS)
1974         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1975           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1976           -path './qa/*.py' | \
1977           etags -l python -a -
1978
1979 .PHONY: coverage
1980
1981 COVERAGE_TESTS=
1982 if WANT_HTOOLS
1983 COVERAGE_TESTS += hs-coverage
1984 endif
1985 if PY_UNIT
1986 COVERAGE_TESTS += py-coverage
1987 endif
1988
1989 coverage: $(COVERAGE_TESTS)
1990
1991 .PHONY: py-coverage
1992 py-coverage: $(GENERATED_FILES) $(python_tests)
1993         @test -n "$(PYCOVERAGE)" || \
1994             { echo 'python-coverage' not found during configure; exit 1; }
1995         set -e; \
1996         COVERAGE=$(PYCOVERAGE) \
1997         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1998         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1999         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2000         $(PLAIN_TESTS_ENVIRONMENT) \
2001         $(abs_top_srcdir)/autotools/gen-py-coverage \
2002         $(python_tests)
2003
2004 .PHONY: hs-coverage
2005 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2006         rm -f *.tix
2007         $(MAKE) $(AM_MAKEFLAGS) hs-check
2008         @mkdir_p@ $(COVERAGE_HS_DIR)
2009         hpc sum --union $(HPCEXCL) \
2010           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2011         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2012         hpc report coverage-hs.tix
2013         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2014
2015 # Special "kind-of-QA" target for htools, needs special setup (all
2016 # tools compiled with -fhpc)
2017 .PHONY: live-test
2018 live-test: all
2019         set -e ; \
2020         cd src; \
2021         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2022         rm -f *.tix *.mix; \
2023         ./live-test.sh; \
2024         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2025           --output=live-test.tix ; \
2026         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2027         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2028           --srcdir=.. $(HPCEXCL) ; \
2029         hpc report --srcdir=.. live-test $(HPCEXCL)
2030
2031 commit-check: autotools-check distcheck lint apidoc
2032
2033 autotools-check:
2034         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2035   $(abs_top_srcdir)/test/autotools/*-*.test \
2036   -- --hide-successes
2037
2038 .PHONY: gitignore-check
2039 gitignore-check:
2040         @if [ -n "`git status --short`" ]; then \
2041           echo "Git status is not clean!" 1>&2 ; \
2042           git status --short; \
2043           exit 1; \
2044         fi
2045
2046 # target to rebuild all man pages (both groff and html output)
2047 .PHONY: man
2048 man: $(man_MANS) $(manhtml)
2049
2050 # Target that builds all binaries (including those that are not
2051 # rebuilt except when running the tests)
2052 .PHONY: really-all
2053 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2054
2055 # we don't need the ancient implicit rules:
2056 %: %,v
2057 %: RCS/%,v
2058 %: RCS/%
2059 %: s.%
2060 %: SCCS/s.%
2061
2062 -include ./Makefile.local
2063
2064 # vim: set noet :